#include <stdio.h>
#include <MClib.h>

#define MATRIX_SIZE 500

int a[MATRIX_SIZE][MATRIX_SIZE];
int b[MATRIX_SIZE][MATRIX_SIZE];
int c[MATRIX_SIZE][MATRIX_SIZE];

static unsigned long next = 1;
static unsigned long long int start_clock;

int myrand(void) {
    next = next * 1103515245 + 12345;
    return((unsigned)(next/65536) % 32768);
}

void init(int id_x, int id_y)
{
    if (id_x == 1 && id_y == 1) {
        int i, j;
        for (i = 0; i < MATRIX_SIZE; i++) {
            for (j= 0; j < MATRIX_SIZE; j++) {
                a[i][j] = myrand();
                b[i][j] = myrand();
            }
        }
        MC_clock(&start_clock);
    }
}

void fin(int id_x, int id_y)
{
    if (id_x == 1 && id_y == 1) {
        unsigned long long int clock;
        MC_clock(&clock);
        printf("cycle: %llu\n", clock - start_clock);
    }
}

void matrixprint(int a[MATRIX_SIZE][MATRIX_SIZE])
{
    int i, j;
    for (i = 0; i < MATRIX_SIZE; i++) {
        for (j= 0; j < MATRIX_SIZE; j++) {
            printf("%05d ", a[i][j]);
        }
        printf("\n");
    }
}

void debugprint(int id_x, int id_y)
{
    if (id_x == 1 && id_y == 1) {
        printf("a\n");
        matrixprint(a);
        printf("b\n");
        matrixprint(b);
        printf("c\n");
        matrixprint(c);
    }
}

int main()
{
    int id_x, id_y, rank_x, rank_y;
    MC_init(&id_x, &id_y, &rank_x, &rank_y);

    init(id_x, id_y);

    if (id_x == 1 && id_y == 1) {
        int i, j;
        for (i = 0; i < MATRIX_SIZE; i++) {
            for (j= 0; j < MATRIX_SIZE; j++) {
                c[i][j] = a[i][j] + b[i][j];
            }
        }
    }

    fin(id_x, id_y);
    //debugprint(id_x, id_y);
    
    MC_finalize();
    return 0;
}
