/**********************************************************************/
/* Many-Core Architecture Research Project       Arch Lab. TOKYO TECH */
/**********************************************************************/
#include "MClib.h"

#define SIZE 16
int array[SIZE];

/**********************************************************************/
int main(int argc, char *args[])
{
    int i;
    int id_x, id_y, rank_x, rank_y;
    MC_init(&id_x, &id_y, &rank_x, &rank_y);

    for (i = 0; i < SIZE/sizeof(int); i++)
        array[i] = 0;

    if (id_x == 1 && id_y == 1) {
        for (i = 0; i < SIZE/sizeof(int); i++)
            array[i] = i + 1;

        int dst;
        setidxy(&dst, rank_x, rank_y);
        MC_dma_put(dst, (void*)array, (void*)array, SIZE, 4, 4);
    }

    if (id_x == rank_x && id_y == rank_y) {
        while(*(volatile int*)&array[SIZE/sizeof(int) - 1] == 0);

        for(i = 0; i < SIZE/sizeof(int); i++)  
            printf("array[%d] %4d\n", i, array[i]);
    }

    MC_finalize();
    return 0;
}

/**********************************************************************/
