/**********************************************************************/
/* SimMc: Simulator for Many-Core Architecture Research Environment   */
/* Copyright (C) 2010-2013 Arch Lab. Tokyo Institute of Technology    */
/*  Licensed under GPL. See COPYING file for more information.        */
/**********************************************************************/
#pragma once

/* 128-bit Xorshift RNG                                               */
/**********************************************************************/
class RandGen {
 private:
    static unsigned int xorshift() {
        static unsigned int x = 123456789;
        static unsigned int y = 362436069;
        static unsigned int z = 521288629;
        static unsigned int w = 88675123;
        unsigned int t = x ^ (x << 11);
        x = y;
        y = z;
        z = w;
        return w = w ^ (w >> 19) ^ (t ^ (t >> 8));
    }
 public:
    static double generate()
        { return (double) xorshift() / (1ll << 32); }
    static unsigned int generate(unsigned int x)
        { if (x != 0) return xorshift() % x; else return 0; }
};

/**********************************************************************/
