/**********************************************************************/
/* SimMc: Simulator for Many-Core Architecture Research Environment   */
/* Copyright (C) 2010-2013 Arch Lab. Tokyo Institute of Technology    */
/*  Licensed under GPL. See COPYING file for more information.        */
/**********************************************************************/
#pragma once

#include "../common/inttypes.h"
#include <stdio.h>

/**********************************************************************/
class Core {
 protected:
    MainMemory *mc;

 public:
    ullint cycle;
    char pidstr[7];

    Core() { cycle = 0; pidstr[0] = '\0'; };
    virtual ~Core() {};
    virtual void init(MainMemory *mem) { mc = mem; };
    virtual void drive() {};
    virtual void update() { cycle++; };
    virtual bool running() { return false; };
    virtual uint064_t getinstcount() { return 0; }
    void setpidstr(uint x, uint y) {
        pidstr[0] = (x < 10) ? ' ' : '0' + (x / 10);
        pidstr[1] = '0' + (x % 10);
        pidstr[2] = ',';
        pidstr[3] = ' ';
        pidstr[4] = (y < 10) ? ' ' : '0' + (y / 10);
        pidstr[5] = '0' + (y % 10);
        pidstr[6] = '\0';
    }
};

/**********************************************************************/
