/**********************************************************************
 * SimMips: Simple Computer Simulator of MIPS                         *
 * Copyright (C) 2008-2012 Arch Lab. Tokyo Institute of Technology    *
 *  Dual licensed under New BSD or GPL v2 licenses.                   *
 *  See COPYING file on the base directory for more information.      *
 **********************************************************************/
#include "syscallplus.h"

#ifdef BASE_MODE_FLOAT
#include "../core/float.h"
#else
#include "../core/define.h"
#endif

/**********************************************************************/
void Mips::syscall()
{
    if (as->r[REG_V0] == SYS_EXIT) {
        state = CPU_STOP;
        return;
    }
    if (! sc.initialized)
        sc.init(mc, ss->heapptr, as->r[REG_SP]);
    sc.silent_mode = ss->silent_mode;
        
    sc.syscall(as->r, cycle);
}

/**********************************************************************/
