/**********************************************************************/
/* SimMc: Simulator for Many-Core Architecture Research Environment   */
/* Copyright (C) 2010-2013 Arch Lab. Tokyo Institute of Technology    */
/*  Licensed under GPL. See COPYING file for more information.        */
/**********************************************************************/
#pragma once

#include "packet.h"
#include <vector>

/**********************************************************************/
class Arbiter {
 public:
    int width, lastgrant;
    bool fix_priority;

    void init(int width, bool fix_priority);
    void arbitrate(std::vector<int> &request, std::vector<int> &grant);
    void setwinner(std::vector<int> &grant);
};

/**********************************************************************/
class Allocator {
 private:
    int width;
    std::vector<Arbiter> arb_in, arb_out;
    std::vector<std::vector<int> > mid, tr;
    void transpose(std::vector<std::vector<int> > &a,
                   std::vector<std::vector<int> > &b);
 public:
    void init(int width, bool fix_priority);
    void allocate(std::vector<std::vector<int> > &request,
                  std::vector<std::vector<int> > &grant);
};

/**********************************************************************/











