/**********************************************************************/
/* SimMc: Simulator for Many-Core Architecture Research Environment   */
/* Copyright (C) 2010-2013 Arch Lab. Tokyo Institute of Technology    */
/*  Licensed under GPL. See COPYING file for more information.        */
/**********************************************************************/
#include "packet.h"

/* 128 bits/cycle network, Max payload 128 Bytes/packet (9 flits)     */
/**********************************************************************/
const int Packet::def[Packet::NUM_TYPE]
                     [Packet::MAX_FLIT + 1]
                     [Flit::MAX_FLIT_WORDS] =
 // PACKET_PUT32
{{{FT_HEADER, FT_ADDR_L, 0,         0},
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_END}},
 // PACKET_PUT32_STRIDE
 {{FT_HEADER, FT_ADDR_L, FT_STRIDE, 0},
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_END}},
 // PACKET_PUT64
 {{FT_HEADER, FT_ADDR_L, FT_ADDR_H, 0},
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_DATA,   FT_DATA,   FT_DATA,   FT_DATA}, 
  {FT_END}},
 // PACKET_PUT32_ACKNACK
 {{FT_HEADER, FT_ADDR_L, FT_IMM,    0},
  {FT_END}}};

/**********************************************************************/
