/**********************************************************************/
/* SimMc: Simulator for Many-Core Architecture Research Environment   */
/* Copyright (C) 2010-2013 Arch Lab. Tokyo Institute of Technology    */
/*  Licensed under GPL. See COPYING file for more information.        */
/**********************************************************************/
#pragma once

#include "connectable.h"
#include "packet.h"
#include "../common/config.h"
#include <vector>

static const ullint WARM_UP_CYCLE_DEF =  5000;
static const ullint SIM_CYCLE_DEF     = 10000;

/* Packet Generator, used in SimMc-NoC                                */
/**********************************************************************/
class PacketGen : public Connectable {
 public:
    uint id;
    int num_channel;
    bool lookahead_rc, credit_fc;
    ullint cycle, warm_cycle, main_cycle;
    ullint num_send, num_recv, num_recv_main, sum_latency;

    std::vector<Flit> send_queue;

    PacketGen();
    void init(uint id, SystemConfig &sc);
    void addpacket(uint dest, int length, int ch);
    void drive();
    void update();
};

/**********************************************************************/
