/**********************************************************************/
/* SimMc: Simulator for Many-Core Architecture Research Environment   */
/* Copyright (C) 2010-2013 Arch Lab. Tokyo Institute of Technology    */
/*  Licensed under GPL. See COPYING file for more information.        */
/**********************************************************************/
#include "routecomp.h"

/* X-Y dimension-order routing                                        */
/**********************************************************************/
int RouteComp::getdir(uint cid, uint did, int cdir, int ch)
{
    ch = ch;
    int cx = IDX(cid);
    int cy = IDY(cid);
    int dx = IDX(did);
    int dy = IDY(did);
    cx += (cdir == DIR_W) ? -1 : (cdir == DIR_E) ?  1 : 0;
    cy += (cdir == DIR_N) ? -1 : (cdir == DIR_S) ?  1 : 0;
    return ((cx > dx) ? DIR_W : (cx < dx) ? DIR_E :
            (cy > dy) ? DIR_N : (cy < dy) ? DIR_S : DIR_C);
}

/**********************************************************************/
