/**********************************************************************/
/* SimMc: Simulator for Many-Core Architecture Research Environment   */
/* Copyright (C) 2010-2013 Arch Lab. Tokyo Institute of Technology    */
/*  Licensed under GPL. See COPYING file for more information.        */
/**********************************************************************/
#pragma once

#include <vector>

/**********************************************************************/
class VCRequest {
 protected:
    std::vector<std::vector<int> > req_ok;
 public:
    VCRequest(int num_channel) {
        std::vector<int> tmp;
        tmp.resize(num_channel, 0);
        req_ok.resize(num_channel, tmp);
    }
    bool ok (int src, int dest) { return req_ok[src][dest]; }
};

/**********************************************************************/
class VCRequestAll : public VCRequest {
 public:
    VCRequestAll(int num_channel) : VCRequest(num_channel) {
        for (int i = 0; i < num_channel; i++)
            for (int j = 0; j < num_channel; j++)
                req_ok[i][j] = 1;
    }
};

/**********************************************************************/
class VCRequestFix : public VCRequest {
 public:
    VCRequestFix(int num_channel) : VCRequest(num_channel) {
        for (int i = 0; i < num_channel; i++)
            req_ok[i][i] = 1;
    }
};

/**********************************************************************/
