/**********************************************************************/
/* SimMc: Simulator for Many-Core Architecture Research Environment   */
/* Copyright (C) 2010-2013 Arch Lab. Tokyo Institute of Technology    */
/*  Licensed under GPL. See COPYING file for more information.        */
/**********************************************************************/
#include "../../sim/network/allocator.h"
#include <iostream>

#define W 5
const int request[W][W] = {
    {0, 2, 1, 2, 1},
    {1, 0, 2, 2, 1},
    {2, 0, 0, 2, 2},
    {1, 2, 1, 0, 2},
    {2, 2, 2, 0, 0}};
const char *message[2] = {"++ Fixed Priority ++", "++ iSlip ++"};

/**********************************************************************/
int main (void)
{
    Allocator alloc[2];
    int total = 0;
    std::vector<std::vector<int> > rest, grant;
    std::vector<int> tmp(W, 0);
    rest.assign(W, tmp);
    grant.assign(W, tmp);
    alloc[0].init(W, true);
    alloc[1].init(W, false);
    
    for (int loop = 0; loop < 2; loop++) {
        std::cout << message[loop] << std::endl;
        for (int i = 0; i < W; i++)
            for (int j = 0; j < W; j++) {
                rest[i][j] = request[i][j];
                total += request[i][j];
            }
        
        while (total > 0) {
            alloc[loop].allocate(rest, grant);
            for (int i = 0; i < W; i++) {
                std::cout << "[ ";
                for (int j = 0; j < W; j++) {
                    std::cout << rest[i][j] << ' ';
                    rest[i][j] -= grant[i][j];
                    total -= grant[i][j];
                }
                std::cout << "] [";
                for (int j = 0; j < W; j++)
                    std::cout << ((grant[i][j]) ? '*' : ' ');
                std::cout << ']' << std::endl;
            }
            std::cout << std::endl;
        }
        std::cout << std::endl;
    }
    return 0;
}

/**********************************************************************/
















